* PARSER.H
* PARSER tokens
* Copyright (c) 2004 Ladybridge Systems, All Rights Reserved

* Values for Keyword VOC tokens

* Values over 10000 may be used freely by developers for their own purposes
* and will never be used by Ladybridge Systems (though the keyword name may
* appear in a future release with a "normal" value).
* It is recommended that developers register any proposed new keyword value
* with us to avoid clashes.

$define KW$FILLER           0
$define KW$DICT             1
$define KW$DATA             2
$define KW$DIRECTORY        3
$define KW$DYNAMIC          4
$define KW$ALL              5
$define KW$GROUP.SIZE       6
$define KW$LARGE.RECORD     7
$define KW$MINIMUM.MODULUS  8
$define KW$SPLIT.LOAD       9
$define KW$MERGE.LOAD      10
$define KW$TO              11
$define KW$FROM            12
$define KW$REPORTING       13
$define KW$DELETING        14
$define KW$UPDATING        15
$define KW$OVERWRITING     16
$define KW$NO.PAGE         17
$define KW$LPTR            18
$define KW$ON              19
$define KW$OFF             20
$define KW$WITH            21
$define KW$EVERY           22
$define KW$AND             23
$define KW$OR              24
$define KW$LOW.REL.OP      25    ;* Start of relational operators
$define KW$EQ              25
$define KW$NE              26
$define KW$LT              27
$define KW$LE              28
$define KW$GE              29
$define KW$GT              30
$define KW$LIKE            31
$define KW$UNLIKE          32
$define KW$SAID            33
$define KW$HIGH.REL.OP     31    ;* End of relational operators
$define KW$CHANGED         34
$define KW$FORCE           35
$define KW$CLOSE           36
$define KW$FILE            37
$define KW$WIDTH           38
$define KW$LINES           39
$define KW$TOP.MARGIN      40
$define KW$BOTTOM.MARGIN   41
$define KW$LEFT.MARGIN     42
$define KW$RESET           43
$define KW$QUERY           44
$define KW$LOCAL           45
$define KW$PATHNAME        46
$define KW$CRT             47
$define KW$COUNT.SUP       48
$define KW$UNION           49
$define KW$INTERSECTION    50
$define KW$DIFFERENCE      51
$define KW$LISTING         52
$define KW$DEBUGGING       53
$define KW$NO.WAIT         54
$define KW$VERTICALLY      55
$define KW$BY              56
$define KW$COL.HDG         57
$define KW$FMT             58
$define KW$HEADING         59
$define KW$AS              60
$define KW$ID.SUP          61
$define KW$COL.SPACES      62
$define KW$NOXREF          63
$define KW$CONV            64
$define KW$SAMPLE          65
$define KW$SAMPLED         66
$define KW$BY.DSND         67
$define KW$NO              68
$define KW$EVAL            69
$define KW$DBL.SPC         70
$define KW$AVERAGE         71
$define KW$BREAK.ON        72
$define KW$BREAK.SUP       73
$define KW$CALC            74
$define KW$COL.HDR.SUPP    75
$define KW$COL.SUP         76
$define KW$DET.SUP         77
$define KW$ENUMERATE       78
$define KW$FOOTING         79
$define KW$GRAND.TOTAL     80
$define KW$HDR.SUP         81
$define KW$ID.ONLY         82
$define KW$MAX             83
$define KW$MIN             84
$define KW$NEW.PAGE        85
$define KW$NO.SPLIT        86
$define KW$PERCENTAGE      87
$define KW$SAVING          88
$define KW$TOTAL           89
$define KW$UNIQUE          90
$define KW$NO.NULLS        91
$define KW$SINGLE.VALUE    92
$define KW$MULTI.VALUE     93
$define KW$BRIEF           94
$define KW$NO.CASE         95
$define KW$VERIFY.SUP      96
$define KW$WAIT            97
$define KW$EXCLUSIVE       98
$define KW$CREATING        99
$define KW$USING          100
$define KW$INQUIRING      101
$define KW$GLOBAL         102
$define KW$REQUIRE.SELECT 103
$define KW$DEFAULT        104
$define KW$AT             105
$define KW$POSTSCRIPT     106
$define KW$USER           107
$define KW$FILELOCK       108
$define KW$WHEN           109
$define KW$PROMPT         110
$define KW$BREAK          111
$define KW$CASE           112
$define KW$INVERT         113
$define KW$NOINVERT       114
$define KW$DISPLAY        115
$define KW$STATISTICS     116
$define KW$INFORM         117
$define KW$NO.MATCH       118
$define KW$ALL.MATCH      119
$define KW$COUNT          120
$define KW$VERIFY         121
$define KW$BY.EXP         122
$define KW$BY.EXP.DSND    123
$define KW$PAN            124
$define KW$SCROLL         125
$define KW$ASSOC          126
$define KW$ASSOC.WITH     127
$define KW$DISPLAY.LIKE   128
$define KW$NFMT           129
$define KW$NEXT           130
$define KW$RAW            131
$define KW$LABEL          132
$define KW$NO.DEFAULT     133
$define KW$CURRENCY       134
$define KW$THOUSANDS      135
$define KW$DECIMAL        136
$define KW$DETAIL         137
$define KW$REQUIRE.INDEX  138
$define KW$NO.INDEX       139
$define KW$LEVEL          140
$define KW$CLEAR          141
$define KW$GDI            142
$define KW$DELIMITER      143
$define KW$TASKLOCK       144
$define KW$COPIES         145
$define KW$BANNER         146
$define KW$NO.QUERY       147
$define KW$BETWEEN        148
$define KW$VERSION        149
$define KW$NODEFAULT      150
$define KW$PORTRAIT       151
$define KW$LANDSCAPE      152
$define KW$LNUM           153
* 154 reserved for future use
$define KW$KEEP.OPEN      155
$define KW$BAUD           156
$define KW$BITS           157
$define KW$PARITY         158
$define KW$NONE           159
$define KW$ODD            160
$define KW$EVEN           161
$define KW$MARK           162
$define KW$SPACE          163
$define KW$STOP.BITS      164
$define KW$NEWLINE        165
$define KW$NO.LABEL       166
$define KW$XREF           167
$define KW$CUMULATIVE     168
$define KW$PRE.WRITE      169
$define KW$PRE.DELETE     170
$define KW$POST.WRITE     171
$define KW$POST.DELETE    172
$define KW$READ           173
$define KW$RETURN         174
$define KW$FORM           175
$define KW$OPTIONS        176
$define KW$PCODE          177
$define KW$PREFIX         178
$define KW$EXCLUDE.REMOTE 179
$define KW$INCLUDE.REMOTE 180
$define KW$SPOOLER        181
$define KW$IMMEDIATE      182
$define KW$COL.HDG.ID     183
$define KW$CSV            184
$define KW$LOCKING        185
$define KW$PCL            186
$define KW$DUPLEX         187
$define KW$SHORT          188
$define KW$OVERLAY        189
$define KW$CPI            190
$define KW$PAPER.SIZE     191
$define KW$LPI            192
$define KW$BOXED          193
$define KW$SYMBOL.SET     194
$define KW$WEIGHT         195
$define KW$COLOUR         196
$define KW$BINARY         197
$define KW$POSITIONED     198
$define KW$STYLE          199
$define KW$HEX            200
$define KW$NO.OBJECT      201
$define KW$PRE.CLEAR      202
$define KW$POST.CLEAR     203
$define KW$ABSENT.NULL    204
$define KW$REPEATING      205
$define KW$STATIC         206
$define KW$APPENDING      207
$define KW$NO.RESIZE      208
$define KW$RESIZE         209
$define KW$PAGESEQ        210
$define KW$ENCRYPT        211
$define KW$GROUP          212
$define KW$TELNET         213
$define KW$INTERNAL       214

* ----------------------------------------------------------------------
* !PARSER action key values

$define PARSER$RESET        0
$define PARSER$GET.TOKEN    1
$define PARSER$GET.REST     2
$define PARSER$EXPAND       3
$define PARSER$LOOK.AHEAD   4
$define PARSER$MFILE        5  ;* Like GET.TOKEN but allows multifile syntax

* !PARSER token type values

$define PARSER$END          0
$define PARSER$TOKEN        1
$define PARSER$STRING       2
$define PARSER$COMMA        3
$define PARSER$LBR          4
$define PARSER$RBR          5
